window.addEventListener("load", function(e) { hi.init(e); }, false);

var hi =
{
    cache: {},
    cachesize: 0,

	init: function(e)
	{
		var content = document.getElementById("content");

//		document.getElementById("statusbar-hostip").setAttribute("collapsed", false);
		content.addEventListener("load", this.onPageLoad, true);
		content.addEventListener("select", this.onSelectTab, true);
		content.addEventListener("pageshow", this.onPageLoad, true);
	},

	onPageLoad: function(e)
	{
		var url = window.content.document.location;
		var ip = hi.dnsResolve(url.host);
//		if(!isLocal(ip))
		hi.fetchInfo(ip);
	},

	onSelectTab: function(e)
	{
		if(e.originalTarget.nodeName == "xul:tabs")
			return false;
		var selTab = e.originalTarget.selectedIndex;
		var selDoc = e.originalTarget.childNodes[selTab].childNodes[1];
		//for Firefox 2.0 and higher:
		if(!selDoc)
			var selDoc = e.originalTarget.childNodes[selTab].firstChild;
		var sdContent = selDoc.contentDocument;
		var url = sdContent.location;

		var ip = "";
		try
		{
			var ip = hi.dnsResolve(url.host);
		}
		catch(exc) {/* just do nothing */}

		hi.fetchInfo(ip);
	},

    _dns: Components.classes["@mozilla.org/network/dns-service;1"].getService(Components.interfaces.nsIDNSService),

	dnsResolve: function (host)
	{
		try
		{
			return hi._dns.resolve(host, 0).getNextAddrAsString();
		}
		catch (e) {return "";}
	},

	isLocal: function(ip)
	{
	    var rx10 = /^10\.\d+\.\d+\.\d+$/;
    	var rx169 = /^169\.254\.\d+\.\d+$/;
	    var rx172 = /^172\.([0-2]\d|3[0-1])\.\d+\.\d+$/;
    	var rx192 = /^192\.168\.\d+\.\d+$/;
		if(ip.match(rx10) || ip.match(rx169) || ip.match(rx172) || ip.match(rx192))
			return true;
		else
			return false;
	},

	fetchInfo: function(ip)
	{
		if(!ip)
		{
//			hi.hide();
			hi.showInfo('0.0.0.0');
			return false;
		}
		
		if(typeof(hi.cache[ip]) != "undefined")
		{
			hi.showInfo(ip);
		}
		else
		{
			var req = new XMLHttpRequest();
			req.open("GET", "http://api.hostip.info/?ip="+ip, true);
			req.onreadystatechange = function()
			{
				if (req.readyState == 4)
				{
					var doc = req.responseXML;
					hi.cache[ip] = doc;
					hi.cachesize = 0;
					for(var i in hi.cache)
					{
						hi.cachesize += hi.cache[i].toJSONString();
					}
					hi.showInfo(ip);
				}
			};
			req.send(null);
		}
		return true;
	},

	showInfo: function(ip)
	{
		var doc = hi.cache[ip];
		var flagpath = "chrome://hostip/content/flags/";
		var hostip = doc.getElementsByTagName("Hostip")[0];
		var countryAbbrevEl = hostip.getElementsByTagName("countryAbbrev")[0];
		var cityEl = hostip.getElementsByTagName("name")[0];
		var countryNameEl = hostip.getElementsByTagName("countryName")[0];

		var countryAbbr = countryAbbrevEl.firstChild.nodeValue;
		var city = cityEl.firstChild.nodeValue;
		var countryName = countryNameEl.firstChild.nodeValue;

		hi.change(city, countryName+", "+city+", "+ip, flagpath+countryAbbr.toLowerCase()+".png", ip);
	},

	hide: function()
	{
	    var el = document.getElementById("statusbar-hostip");
		if(!el.collapsed)
			el.collapsed = true;
	},

	change: function(label, tooltip, src, ip)
	{
	    el = document.getElementById("statusbar-hostip");
		if(el.collapsed)
			el.collapsed = false;
		el.setAttribute("label", label);
		el.setAttribute("tooltiptext", tooltip);
		el.setAttribute("src", src);	
		el.addEventListener("click", function(e) {window.content.document.location='http://www.hostip.info/?spip='+ip}, false);
	}
}
